﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace XMLEplorer2
{
    public partial class Form1 : Form
    {
        private XmlDocument doc;
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            fd.InitialDirectory = Application.StartupPath;
            DialogResult result = fd.ShowDialog();
            if (result == DialogResult.OK)
            {
                doc = new XmlDocument();
                doc.Load(fd.FileName);
                TreeNode root = new TreeNode(doc.DocumentElement.Name);
                treeViewDoc.Nodes.Add(root);
                foreach (XmlElement element in doc.DocumentElement.ChildNodes)
                {
                    TreeNode book = new TreeNode("Book Id: " +
                        element.Attributes["bookId"].Value);
                    root.Nodes.Add(book);
                    if (element.HasChildNodes)
                    {
                        foreach (XmlElement element2 in element.ChildNodes)
                        {
                            TreeNode book2 = new TreeNode(element2.Name + ": " +
                                element2.InnerText);
                            book.Nodes.Add(book2);
                        }
                    }
                }
            }
        }

        private void buttonSelectTag_Click(object sender, EventArgs e)
        {
            if (doc != null)
            {
                XmlNodeList list = doc.GetElementsByTagName(textBoxTagName.Text);
                foreach (XmlNode node in list)
                {
                    SelectNode(node.Name);
                }
            }
        }

        private void SelectNode(string n)
        {
            foreach (TreeNode t in treeViewDoc.TopNode.Nodes)
            {
                foreach (TreeNode t2 in t.Nodes)
                {
                    if (t2.Text.StartsWith(n))
                        t2.NodeFont = new Font("Arial", 8, FontStyle.Bold);
                }
            }
        }
    }
}
